org.apache.fop.afp.modca.triplets

## Class ObjectClassificationTriplet

- java.lang.Object
- - org.apache.fop.afp.modca.AbstractAFPObject
  - - org.apache.fop.afp.modca.triplets.AbstractTriplet
    - - org.apache.fop.afp.modca.triplets.ObjectClassificationTriplet

All Implemented Interfaces:
  Triplet, Streamable, StructuredData

    public class ObjectClassificationTriplet
    extends AbstractTriplet

The Object Classification is used to classify and identify object data. The object data may or may not be defined by an IBM presentation architecture

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.fop.afp.modca.AbstractAFPObject

`AbstractAFPObject.Category, AbstractAFPObject.Type`

### Field Summary

Fields
`static byte` `CLASS_DATA_OBJECT_FONT` Data object font.
`static byte` `CLASS_EXECUTABLE_PROGRAM` This is not a presentation object, the scope of this object is not defined
`static byte` `CLASS_SECONDARY_RESOURCE` This is a resource used by a presentation object that may itself be a resource.
`static byte` `CLASS_SETUP_FILE` Setup information file, document level.
`static byte` `CLASS_TIME_INVARIANT_PAGINATED_PRESENTATION_OBJECT` The scope of this object is the including page or overlay
`static byte` `CLASS_TIME_VARIANT_PRESENTATION_OBJECT` The scope of this object is not defined

### Fields inherited from class org.apache.fop.afp.modca.triplets.AbstractTriplet

`id`

### Fields inherited from class org.apache.fop.afp.modca.AbstractAFPObject

`LOG, SF_CLASS, SF_HEADER_LENGTH`

### Fields inherited from interface org.apache.fop.afp.modca.triplets.Triplet

`AREA_DEFINITION, ATTRIBUTE_QUALIFIER, ATTRIBUTE_VALUE, CHARACTER_ROTATION, CMR_TAG_FIDELITY, CODED_GRAPHIC_CHARACTER_SET_GLOBAL_IDENTIFIER, COLOR_FIDELITY, COLOR_MANAGEMENT_RESOURCE_DESCRIPTOR, COLOR_SPECIFICATION, COMMENT, DATA_OBJECT_FONT_DESCRIPTOR, DESCRIPTOR_POSITION, DEVICE_APPEARANCE, ENCODING_SCHEME_ID, EXTENDED_RESOURCE_LOCAL_IDENTIFIER, FINISHING_FIDELITY, FINISHING_OPERATION, FONT_DESCRIPTOR_SPECIFICATION, FONT_FIDELITY, FONT_HORIZONTAL_SCALE_FACTOR, FONT_RESOLUTION_AND_METRIC_TECHNOLOGY, FULLY_QUALIFIED_NAME, LOCALE_SELECTOR, MAPPING_OPTION, MAX_LENGTH, MEASUREMENT_UNITS, MEDIA_EJECT_CONTROL, MEDIA_FIDELITY, MEDIUM_MAP_PAGE_NUMBER, MEDIUM_ORIENTATION, MODCA_INTERCHANGE_SET, OBJECT_AREA_SIZE, OBJECT_BYTE_EXTENT, OBJECT_BYTE_OFFSET, OBJECT_CLASSIFICATION, OBJECT_COUNT, OBJECT_DATE_AND_TIMESTAMP, OBJECT_FUNCTION_SET_SPECIFICATION, OBJECT_OFFSET, OBJECT_STRUCTURED_FIELD_EXTENT, OBJECT_STRUCTURED_FIELD_OFFSET, PAGE_OVERLAY_CONDITIONAL_PROCESSING, PAGE_POSITION_INFORMATION, PARAMETER_VALUE, PRESENTATION_CONTROL, PRESENTATION_SPACE_MIXING_RULE, PRESENTATION_SPACE_RESET_MIXING, RENDERING_INTENT, RESOURCE_LOCAL_IDENTIFIER, RESOURCE_OBJECT_INCLUDE, RESOURCE_SECTION_NUMBER, RESOURCE_USAGE_ATTRIBUTE, TEXT_FIDELITY, TONER_SAVER, UNIVERSAL_DATE_AND_TIMESTAMP, UP3I_FINISHING_OPERATION`

### Constructor Summary

Constructors
Constructor and Description
`ObjectClassificationTriplet(byte objectClass, Registry.ObjectType objectType, boolean dataInContainer, boolean containerHasOEG, boolean dataInOCD)` Main constructor
`ObjectClassificationTriplet(byte objectClass, Registry.ObjectType objectType, boolean dataInContainer, boolean containerHasOEG, boolean dataInOCD, String objLev, String compName)` Fully parameterized constructor

### Method Summary

All Methods Instance Methods Concrete Methods
`int` `getDataLength()` Returns the data length of this structured field
`byte[]` `getStructureFlagsAsBytes(boolean dataInContainer, boolean containerHasOEG, boolean dataInOCD)` Returns the structured field flags
`void` `writeToStream(OutputStream os)` DataStream objects must implement the writeToStream() method to write its data to the given OutputStream

### Methods inherited from class org.apache.fop.afp.modca.triplets.AbstractTriplet

`getData, getId`

### Methods inherited from class org.apache.fop.afp.modca.AbstractAFPObject

`copySF, copySF, truncate, writeChunksToStream, writeObjects`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### CLASS_TIME_INVARIANT_PAGINATED_PRESENTATION_OBJECT

    public static final byte CLASS_TIME_INVARIANT_PAGINATED_PRESENTATION_OBJECT

The scope of this object is the including page or overlay

See Also:
  Constant Field Values

#### CLASS_TIME_VARIANT_PRESENTATION_OBJECT

    public static final byte CLASS_TIME_VARIANT_PRESENTATION_OBJECT

The scope of this object is not defined

See Also:
  Constant Field Values

#### CLASS_EXECUTABLE_PROGRAM

    public static final byte CLASS_EXECUTABLE_PROGRAM

This is not a presentation object, the scope of this object is not defined

See Also:
  Constant Field Values

#### CLASS_SETUP_FILE

    public static final byte CLASS_SETUP_FILE

Setup information file, document level. This is not a presentation object,

See Also:
  Constant Field Values

#### CLASS_SECONDARY_RESOURCE

    public static final byte CLASS_SECONDARY_RESOURCE

This is a resource used by a presentation object that may itself be a resource. The scope of the resource is the object that uses the resource.

See Also:
  Constant Field Values

#### CLASS_DATA_OBJECT_FONT

    public static final byte CLASS_DATA_OBJECT_FONT

Data object font. This is a non-FOCA font resource used to present text in a data object. The scope of the resource is the object that uses the resource.

See Also:
  Constant Field Values

### Constructor Detail

#### ObjectClassificationTriplet

    public ObjectClassificationTriplet(byte objectClass,
                                       Registry.ObjectType objectType,
                                       boolean dataInContainer,
                                       boolean containerHasOEG,
                                       boolean dataInOCD)

Main constructor

Parameters:
  `objectClass` - the object class type
  `objectType` - the object type registry entry
  `dataInContainer` - whether the data resides in the container
  `containerHasOEG` - whether the container has an object environment group
  `dataInOCD` - whether the data resides in a object container data structured field

#### ObjectClassificationTriplet

    public ObjectClassificationTriplet(byte objectClass,
                                       Registry.ObjectType objectType,
                                       boolean dataInContainer,
                                       boolean containerHasOEG,
                                       boolean dataInOCD,
                                       String objLev,
                                       String compName)

Fully parameterized constructor

Parameters:
  `objectClass` - the object class type
  `objectType` - the object type registry entry
  `dataInContainer` - whether the data resides in the container
  `containerHasOEG` - whether the container has an object environment group
  `dataInOCD` - whether the data resides in a object container data structured field
  `objLev` - the release level or version number of the object type
  `compName` - the name of the company or organization that owns the object definition

### Method Detail

#### getStructureFlagsAsBytes

    public byte[] getStructureFlagsAsBytes(boolean dataInContainer,
                                           boolean containerHasOEG,
                                           boolean dataInOCD)

Returns the structured field flags

Parameters:
  `dataInContainer` - true if the object data in carried in the object container
  `containerHasOEG` - true if the object container has an object environment group
  `dataInOCD` - true if the object container data carries the object data
Returns:
  the byte value of this structure

#### getDataLength

    public int getDataLength()

Returns the data length of this structured field

Returns:
  the data length of this structured field

#### writeToStream

    public void writeToStream(OutputStream os)
                       throws IOException

DataStream objects must implement the writeToStream() method to write its data to the given OutputStream

Parameters:
  `os` - the outputsteam stream
Throws:
  `IOException` - an I/O exception of some sort has occurred.